package com.malk.paineng;

import com.querydsl.jpa.impl.JPAQueryFactory;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Bean;
import org.springframework.data.jpa.repository.config.EnableJpaAuditing;
import org.springframework.scheduling.annotation.EnableAsync;

import javax.persistence.EntityManager;


@EnableAsync
@EnableJpaAuditing
@SpringBootApplication(scanBasePackages = {"com.malk"})
public class Boot {

    public static void main(String... args) {
        SpringApplication.run(Boot.class, args);
    }

    /**
     * 让Spring管理JPAQueryFactory [不使用Qualifier详见mjava-Boot]
     */
    @Bean
    public JPAQueryFactory jpaQueryFactory(EntityManager entityManager) {
        
        return new JPAQueryFactory(entityManager);
    }
}